# -*- coding: cp1250 -*-
# Heap
# Created by Bc. Petr Novk, 2015/04
# Faculty of Environmental Sciences
# Czech University of Life Sciences Prague 

'''
Modul "halda.py" sead seznam do haldy s nejvtm slem na zatku a 
pomoc funkce cr_list lze vytvoit seazen seznam hodnot.
'''

# Vytvo binrn haldu ze seznamu
def cr_heap (seznam, index=2):
    heap=[]
    for i in seznam:
        inz_el (heap, i, index)
    return heap

# Pid prvek na konec seznamu a nech ho proskkat haldou
def inz_el (sez, x, index=2):
    sez.append (x)
    # Index vloenho sla
    j = len(sez)   
    while j > 1:
        # Index nahrazenho prvku
        p = j / 2  
        # Porovn vloen prvek a jeho nadazen a ppadn je vymn
        if isinstance(sez[p-1],int):
            if sez[j-1] > sez[p-1]: 
                d = sez[j-1]
                sez[j-1] = sez[p-1]
                sez[p-1] = d
                # Posun v hald na pedchdce
                j = p  
            else:                       
                break
        else:
            if sez[j-1][index] > sez[p-1][index]: 
                d = sez[j-1]
                sez[j-1] = sez[p-1]
                sez[p-1] = d 
                # Posun v hald na pedchdce
                j = p  
            else:                       
                break
            
# Odstran prvek z vrcholu haldy a nahrad ho dalm nejvym slem           
def ret_max (heap, index=2):
    # Pesune posledn prvek haldy na vrchol
    heap[0] = heap[-1]  
    del heap [-1]       
    # Index poslednho sla
    j = len(heap)-1     
    # Index porovnvanho sla
    i = 0               
    # Plat pro haldu obsahujc vce, ne jedno slo
    while j > 0: 
        # Index nslednka       
        n = 2*(i+1)-1   
        if n<len(heap):
            if isinstance(heap[n] and heap[i],int):
                # Kontrola zda existuj oba nslednci
                if n < j:
                    # Vybere ten vt
                    if heap [n+1] > heap [n]:
                        n = n+1
                # Je-li slo men ne nslednk, tak se vymn
                if heap[i] < heap[n]:
                    d = heap[n]
                    heap[n] = heap[i]
                    heap[i] = d
                    # Posun v hald na nslednka
                    i = n   
                else:
                    break
            else:
                # Kontrola zda existuj oba nslednci
                if n < j:
                    # Vybere ten vt
                    if heap [n+1][index] > heap [n][index]:
                        n = n+1
                # Je-li slo men ne nslednk, tak se vymn
                if heap[i][index] < heap[n][index]:
                    d = heap[n]
                    heap[n] = heap[i]
                    heap[i] = d
                    # Posun v hald na nslednka
                    i = n   
                else:
                    break                      
        else:
            break

# Funkce pro vytvoen seazenho seznamu z existujc seazen haldy
def cr_list (heap):
    ssez = []
    # Je-li v hald alespo jedin poloka
    while len (heap)>0:
        # vlo nejvt slo z haldy na konec seznamu         
        ssez.append (heap[0])   
        # a vrt maximum na zatek haldy
        ret_max (heap)          
    return ssez

